var PhonePhoneBookGlobal = function() {
    this.blockedPhoneBookGlobal = false;
    this.startIndexPhoneBookGlobal = 0;
    this.itemsPerPagePhoneBookGlobal = 50;

    this._init();
}

PhonePhoneBookGlobal.prototype = {

    _init : function() {
        getApp().log("init phoneBookGlobal");
    },

    getStartIndexPhoneBookGlobal : function() {
        return this.startIndexPhoneBookGlobal;
    },

    getItemsPerPagePhoneBookGlobal : function() {
        return this.itemsPerPagePhoneBookGlobal;
    },

    getItemsPerPageSelectPhoneBookGlobal : function() {
        if(this.itemsPerPagePhoneBookGlobal == 50) {
            return 0;
        } else if(this.itemsPerPagePhoneBookGlobal == 100) {
            return 1;
        } else if(this.itemsPerPagePhoneBookGlobal == 500) {
            return 2;
        } else {
            return 3;
        }
    },
    
    //ZAPIS
    saveRowGlobalPhoneBook : function(self) {
        var line   = self.getAttribute('line');
       
        var newRow = {
            'number'     : $('.number_'+line ).val(),
            'description': $('.description_'+line ).val().toUpperCase()
        };

        if (newRow.number) {
            getApp().addPhoneBookGlobalRow(self.getAttribute('idx'), escape(newRow.number), escape(newRow.description));
        }

        getApp().renderViewPhoneBookGlobal();

        this.blockedPhoneBookGlobal = false;
    },

    //ANULUJ
    cancelRowGlobalPhoneBook : function(self) {
        var line = self.getAttribute('line');

        $('input.description_'+line).val(self.getAttribute('description'));
        $('input.number_'+line).val(self.getAttribute('number'));
        $('input.global_phone_row').attr("readOnly", "true");

        $('.save_global_phone_row').hide();
        $('.cancel_global_phone_row').hide();
        $('.delete_global_phone_row').show();
        $('input.global_phone_row').removeClass('input_disabled');

        this.blockedPhoneBookGlobal = false;
    },

    //USUN
    removeRowGlobalPhoneBook : function(self){
        var oldRow = {
            'number'    : self.getAttribute('number'),
            'description': self.getAttribute('description'),
            'line' : self.getAttribute('line')
        };

        if ((oldRow.number) || (oldRow.description)) {
            getApp().removePhoneBookGlobalRows(self.getAttribute('idx'));
        }
        getApp().renderViewPhoneBookGlobal();

        this.blockedPhoneBookGlobal = false;
    },

    //BLOKADA EDYCYJNEGO POLA
    editRowPhoneGlobalBook : function(self){
        if(!this.blockedPhoneBookGlobal) {
            this._blockInputs(self);
        } else {
            if(!$('.save_global_phone_row').is(':visible')) {
                this._blockInputs(self);
            }
        }
    },

    _blockInputs : function(self) {
        $('input.global_phone_row').addClass('input_disabled');

        $('.save_global_phone_row').hide();
        $('.cancel_global_phone_row').hide();
        $('.delete_global_phone_row').hide();

        var line = self.getAttribute('line');

        var oldRow = {
            'number'    : $('.number_'+line).val(),
            'description': $('.description_'+line).val()
        };

        $('input.line_'+line).removeClass('input_disabled');
        $('input.line_'+line).attr("readOnly", "");
        $('input.description_'+line).keyfilter(/^[A-Za-z0-9\*\#\.\,\!\? ]{1,24}/);
        $('input.number_'+line).keyfilter(/^[0-9\*\#]{1,24}$/);

        $('input.description_'+line).bind("paste", function() {
            setTimeout(function() {
                $('.description_'+line).keyup();
                var txt = getApp().escapeDiacritics($('.description_'+line).val());
                txt = txt.replace(/[^A-Za-z0-9\*\#\.\,\!\? ]/gi, "");
                txt = txt.replace(/\n\t\r\0\v\f/g, "");
                $('.description_'+line).val(txt);
            }, 50);
        });
        $('input.number_'+line).bind("paste", function() {
            setTimeout(function() {
                $('.number_'+line).keyup();
                var txt = getApp().escapeDiacritics($('.number_'+line).val());
                txt = txt.replace(/[^0-9\*\#]/gi, "");
                txt = txt.replace(/\n\t\r\0\v\f/g, "");
                $('.number_'+line).val(txt);
            }, 50);

        });

        $('input.description_'+line).bind("drop", function() {
            $('.description_'+line).trigger("paste");
        });
        $('input.number_'+line).bind("drop", function() {
            $('.number_'+line).trigger("paste");
        });

        $('input.description_'+line).bind("change", function() {
            $('.description_'+line).trigger("paste");
        });
        $('input.number_'+line).bind("change", function() {
            $('.number_'+line).trigger("paste");
        });

        $('input.description_'+line).bind("keyup", function(){
            var numberLen = $('.number_'+line ).val().length;
            var descLen = $('.description_'+line ).val().length;
            var desc = $('.description_'+line ).val();
            if((numberLen>0) && (descLen>0) && (oldRow.description != desc)) {
                $('.save_'+line).show();
            } else {
                $('.save_'+line).hide();
            }
        });
        $('input.number_'+line).bind("keyup", function(){
            var numberLen = $('.number_'+line ).val().length;
            var number = $('.number_'+line ).val();
            var descLen = $('.description_'+line ).val().length;
            if((numberLen>0) && (descLen>0) && (oldRow.number != number)) {
                $('.save_'+line).show();
            } else {
                $('.save_'+line).hide();
            }
        });

        var number = $('.number_'+line ).val().length
        var desc = $('.description_'+line ).val().length;

        $('.cancel_'+line).show();
        $('.delete_'+line).show();

        this.blockedPhoneBookGlobal = true;
    },

    //ODCZYT ILOSCI ELEMENTOW NA STRONE
    changeItemsPerPagePhoneGlobalBook : function(self) {
        var opt = $(self).val();

        this.startIndexPhoneBookGlobal = 0;
        this.blockedPhoneBookGlobal = false;

        if(opt == 50) {
            this.itemsPerPagePhoneBookGlobal = 50;
            getApp().renderViewPhoneBookGlobal();
        } else if(opt == 100) {
            this.itemsPerPagePhoneBookGlobal = 100;
            getApp().renderViewPhoneBookGlobal();
        } else if(opt == 500) {
            this.itemsPerPagePhoneBookGlobal = 500;
            getApp().renderViewPhoneBookGlobal();
        } else {
            this.itemsPerPagePhoneBookGlobal = 1000;
            getApp().renderViewPhoneBookGlobal();
        }
    },

    //NEXT
    nextItemsPhoneGlobalBook : function() {
        this.startIndexPhoneBookGlobal += this.itemsPerPagePhoneBookGlobal;

        if(this.startIndexPhoneBookGlobal > (getApp().getPhoneBookGlobalLength() - 1)) {
            this.startIndexPhoneBookGlobal = getApp().getPhoneBookGlobalLength() - 1;
        }

        this.blockedPhoneBookGlobal = false;
        getApp().renderViewPhoneBookGlobal();
    },

    //PREV
    prevItemsPhoneGlobalBook : function() {
        this.startIndexPhoneBookGlobal -= this.itemsPerPagePhoneBookGlobal;

        if(this.startIndexPhoneBookGlobal < 0) {
            this.startIndexPhoneBookGlobal = 0;
        }
        
        this.blockedPhoneBookGlobal = false;
        getApp().renderViewPhoneBookGlobal();
    },

    //BEGIN
    beginItemsPhoneGlobalBook : function() {
        this.startIndexPhoneBookGlobal = 0;

        this.blockedPhoneBookGlobal = false;
        getApp().renderViewPhoneBookGlobal();
    },

    //END
    endItemsPhoneGlobalBook : function() {
        this.startIndexPhoneBookGlobal = getApp().getPhoneBookGlobalLength() - this.itemsPerPagePhoneBookGlobal;

        this.blockedPhoneBookGlobal = false;
        getApp().renderViewPhoneBookGlobal();
    }
}